//--------------------------------------------------------------
// File     : stm32_ub_fpga.h
//--------------------------------------------------------------

#ifndef STM32_UB_FPGA_H_
#define STM32_UB_FPGA_H_

//--------------------------------------------------------------
// Includes
//--------------------------------------------------------------
#include "stm32_ub_system.h"

// GPIO settings for PROG-B Pin
#define FPGA_PROG_B_PORT	GPIOB
#define FPGA_PROG_B_PIN		GPIO_PIN_15

// GPIO settings for INIT-B Pin
#define FPGA_INIT_B_PORT	GPIOB
#define FPGA_INIT_B_PIN		GPIO_PIN_11

// GPIO settings for CCLK Pin
#define FPGA_CCLK_PORT		GPIOB
#define FPGA_CCLK_PIN		GPIO_PIN_13

// GPIO settings for DATA Pin
#define FPGA_DATA_PORT		GPIOB
#define FPGA_DATA_PIN		GPIO_PIN_12

// GPIO settings for DONE Pin
#define FPGA_DONE_PORT		GPIOB
#define FPGA_DONE_PIN		GPIO_PIN_14


//--------------------------------------------------------------
// return values
#define FPGA_PRG_OK			0x00
#define FPGA_PRG_ERROR1		0x01
#define FPGA_PRG_ERROR2		0x02
#define FPGA_PRG_ERROR3		0x03
#define FPGA_PRG_ERROR4		0x04
#define FPGA_PRG_ERROR5		0x05
#define FPGA_PRG_ERROR6		0x06


//--------------------------------------------------------------
#define FPGA_DELAY_START	2000 // >1000

//--------------------------------------------------------------
typedef struct UB_Bitfile_t
{
  const uint8_t *table;
  uint32_t size;
}UB_Bitfile;


extern UB_Bitfile blinky_bit;


//--------------------------------------------------------------
// global functions
//--------------------------------------------------------------
void UB_Fpga_Init(void);
uint8_t UB_Fpga_Programm(UB_Bitfile *filename);


#endif /* STM32_UB_FPGA_H_ */
